package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_2_2_IntroTitleActor extends ActorScript
{
	public var _Started:Bool;
	public var _TimeBeforeRetreat:Float;
	public var _SlideDirection:String;
	public var _SlideSpeed:Float;
	public var _SpeedChange:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Started", "_Started");
		_Started = false;
		nameMap.set("Time Before Retreat", "_TimeBeforeRetreat");
		_TimeBeforeRetreat = 0.0;
		nameMap.set("Slide Direction", "_SlideDirection");
		_SlideDirection = "";
		nameMap.set("Slide Speed", "_SlideSpeed");
		_SlideSpeed = -5.0;
		nameMap.set("Speed Change", "_SpeedChange");
		_SpeedChange = 0.5;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_Started = false;
		runLater(1000 * _TimeBeforeRetreat, function(timeTask:TimedTask):Void
		{
			_Started = true;
		}, actor);
		actor.killSelfAfterLeavingScreen();
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				g.setFont(getFont(2));
				g.drawString("" + getCurrentSceneName(), 0, 0);
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_Started)
				{
					if((_SlideDirection == "left"))
					{
						actor.setX((actor.getX() - _SlideSpeed));
					}
					else if((_SlideDirection == "right"))
					{
						actor.setX((actor.getX() + _SlideSpeed));
					}
					else if((_SlideDirection == "up"))
					{
						actor.setY((actor.getY() - _SlideSpeed));
					}
					else if((_SlideDirection == "down"))
					{
						actor.setY((actor.getY() + _SlideSpeed));
					}
					_SlideSpeed += _SpeedChange;
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}