package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;
import com.stencyl.graphics.ScaleMode;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Config;
import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.motion.*;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_9_9_BugGenerator extends SceneScript
{
	public var _BugGeneratorList:Array<Dynamic>;
	public var _BugGenerationIntervalFloat:Float;
	public var _SpecialEnemiesList:Array<Dynamic>;
	public var _SpecialBugGeneratorID:Float;
	public var _TimeofAppearanceBeforeDebut:Float;
	public var _CreateEvent:Float;
	public var _Max:Float;
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("Bug Generator List", "_BugGeneratorList");
		_BugGeneratorList = ["Gnat", "Fly", "Hornet", "Mr B"];
		nameMap.set("Bug Generation Interval Float", "_BugGenerationIntervalFloat");
		_BugGenerationIntervalFloat = 0.0;
		nameMap.set("Special Enemies List", "_SpecialEnemiesList");
		_SpecialEnemiesList = ["Silverfish"];
		nameMap.set("Special Bug Generator ID", "_SpecialBugGeneratorID");
		_SpecialBugGeneratorID = 0.0;
		nameMap.set("Time of Appearance Before Debut", "_TimeofAppearanceBeforeDebut");
		_TimeofAppearanceBeforeDebut = 0.0;
		nameMap.set("Create Event", "_CreateEvent");
		_CreateEvent = 0.0;
		nameMap.set("Max", "_Max");
		_Max = 1.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_BugGenerationIntervalFloat = 2;
		
		/* ======================= Every N seconds ======================== */
		runPeriodically(1000 * _BugGenerationIntervalFloat, function(timeTask:TimedTask):Void
		{
			if(wrapper.enabled)
			{
				createRecycledActorOnLayer(getActorTypeByName(("" + _BugGeneratorList[0])), randomInt(100, 700), randomInt(100, 500), engine.getLayerById(0));
			}
		}, null);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}